SystemOrganization addCategory: #MareaMongoDB!

Object subclass: #MARMongoDBGraphPersistency
	instanceVariableNames: ''
	classVariableNames: 'DatabaseConnection'
	poolDictionaries: ''
	category: 'MareaMongoDB'!

!MARMongoDBGraphPersistency commentStamp: 'MarianoMartinezPeck 2/2/2012 17:50' prior: 0!
To start the server run ~/PhD/mongodb-osx-x86_64-2.0.2/bin/mongod
!

!MARMongoDBGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:53'!
database
	^ self databaseConnection databaseNamed: 'Marea'.
	! !

!MARMongoDBGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:51'!
databaseConnection 
	DatabaseConnection isNil ifTrue: [
		DatabaseConnection := self defaultDatabaseConnection].
	^ DatabaseConnection ! !

!MARMongoDBGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 5/31/2012 11:24'!
databaseConnection: aDatabaseConnection
	DatabaseConnection := aDatabaseConnection ! !

!MARMongoDBGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:51'!
defaultDatabaseConnection
	^ (Mongo host: 'localhost' port: 27017) open ! !

!MARMongoDBGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:53'!
graphBlobFromGraphID: graphID	
	^ (self database queryOne: (Dictionary with: '_id'->(OID value: graphID)) collection: 'objectGraphs')  at: 'bytes'.
! !

!MARMongoDBGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:53'!
removeAllGraphs 

	self database drop.! !

!MARMongoDBGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:54'!
removeGraphWithID: graphID

	(self database addCollection: 'objectGraphs') remove: 	(Dictionary with: '_id'->(OID value: graphID)) ! !

!MARMongoDBGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:50'!
reset
	self resetConnection.
	self removeAllGraphs 
	! !

!MARMongoDBGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:54'!
resetConnection
	DatabaseConnection := nil.! !

!MARMongoDBGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:55'!
storeGraphBlob: aByteArray graphID: graphID	

	| mc  |
	mc := self database addCollection: 'objectGraphs'.
	mc  add: (Dictionary new 
	       at: '_id'  put: (OID value: graphID);
	       at: 'bytes' put: aByteArray; yourself). 
! !
